
public class CursorList implements Lista {

	public static final int MAXLUNG = 100;

	/*
	 * La variabile di classe spazio rappresenta l'area di memoria unica in cui verranno memorizzate le diverse liste
	 * 
	 */
	private static Cella[] spazio = new Cella[MAXLUNG];

	/*
	 * Inizializza l'area di memoria unica assegnata a spazio, in maniera tale che il cursore di ciascuna cella
	 * consenta di raggiungere la cella successiva
	 */
	static {
		int i;
		for (i = 1; i < spazio.length - 1; i++) {
			spazio[i] = (new CursorList()).new Cella(new Object(), new Cursore(i + 1));
		}
		//Il cursore della cella in posizione spazio.length - 1 non punta a nulla
		spazio[i] = (new CursorList()).new Cella(null, null);
	}

	private class Cella {

		public Object elemento;

		public Posizione successivo;

		public Cella(Object elemento, Posizione successivo) {
			this.elemento = elemento;
			this.successivo = successivo;
		}
	}

	private static Posizione listalibera = new Cursore(1);

	//private Posizione inizioLista = new Cursore(1);
	private Posizione inizioLista = new Cursore(0);

	public boolean endList(Posizione p) {
		return ((Cursore) p).cursore == 0;
	}

	public Posizione firstList() {
		
		return inizioLista;
	}
	
	public boolean isEmpty() {
		//return ((Cursore) listalibera).cursore == ((Cursore) firstList()).cursore;
		return ((Cursore) firstList()).cursore==0;
	}

	
	public Posizione succ(Posizione p) {
		if (endList(p))
			throw new IndexOutOfBoundsException(((Cursore) p).cursore
					+ " e' ultima posizione della lista");
		return spazio[((Cursore) p).cursore].successivo;
	}


	public Posizione pred(Posizione p) {
		if (((Cursore) p).cursore == ((Cursore) firstList()).cursore)
			throw new IndexOutOfBoundsException(((Cursore) p).cursore
					+ " e' la prima posizione della lista");
		Cursore temp = (Cursore) firstList();
		while (!endList(temp)) {
			if (spazio[temp.cursore].successivo == p)
				return temp;
			else
				temp = (Cursore) succ(temp);
		}
		throw new IndexOutOfBoundsException(((Cursore) p).cursore
				+ " non  una posizione valida");
	}

	
	
	public void insert(Object e, Posizione p) {
		Posizione temp, q;
		int primaPosLibera = ((Cursore) listalibera).cursore;
		if (!isEmpty()) {
			temp = spazio[primaPosLibera].successivo;
			spazio[primaPosLibera].elemento = e;
			spazio[primaPosLibera].successivo = p;
			if (((Cursore) p).cursore == ((Cursore) firstList()).cursore)
				inizioLista = listalibera;
			else{
				q = pred(p);
				spazio[((Cursore) q).cursore].successivo = listalibera;
			}			
				
			listalibera=temp;				
			
		} 
		else {
			// lista vuota
			inizioLista = listalibera;
			listalibera = spazio[primaPosLibera].successivo;
			spazio[primaPosLibera].elemento = e;
			spazio[primaPosLibera].successivo = new Cursore(0);
		}

	}

	
	// Esercizio per Studenti 
	/*
	 * Determina se la posizione passata  ammissibile
	 * p  ammissibile se coincide con le posizioni restituite da firstList, endList
	 * oppure se ammette uun predecessore e un successore, ossia pred(p) e succ(p) non generano eccezione   
	 */
	protected boolean checkPosition(Posizione p) {
		// controllo se p uguale a primo lista oppure uguale a fine lista
		if ((((Cursore) p).cursore == ((Cursore) firstList()).cursore)
				|| endList(p)) {
			// posizione corretta
			return true;
		} else {
			try {
				// se il pred e il succ non lancia eccezione allora la posizione
				//  corretta
				pred(p);
				succ(p);
				return true;
			} catch (Exception e) {
				// se viene lanciata una eccezione allora la posizione non 
				// valida
				return false;
			}
		}
	}
	/*
	 * (non-Javadoc)
	 * @see Lista#readList(Posizione)
	 * Verifica se p  posizione ammissibile
	 * In caso affermativo restituisce l'elemento della cella in posizione p di spazio 
	 */
	public Object readList(Posizione p) {
		// da implemetare
	}

	

	/*
	 * (non-Javadoc)
	 * @see Lista#readList(Posizione)
	 * Verifica se p  posizione ammissibile
	 * In caso affermativo rimpiazza l'elemento della cella in posizione p di spazio con e
	 */
	public void writeList(Object e, Posizione p) {
		// da implementare
	}

	/*
	 * (non-Javadoc)
	 * @see Lista#remove(Posizione)
	 * Verifica che la posizione p sia ammissibile
	 * In caso affermativo si distinguono due case
	 * caso 1: p  la posizione del primo elemento nella lista
	 * 		1) modificare inizioLista in modo che corrisponda alla cella di spazio in posizione successiva a quella che contiene l'elemento che si sta rimuovento
	 * 		2) modificare listalibera in modo che parta da p
	 * caso 2: p non  la posizione del primo elemento della lista 
	 * 		1) usare l'operatore pred per determinare la posizione della cella che contiene l'elemento precedente a quello in posizione p nella lista (denotarla come temp)
	 * 		2) fare in modo che la cella in posizione temp di spazio abbia come successiva la cella che  attualmente successiva a quella che  in posizione p
	 * 		3) modificare listaLibera in modo che abbia come posizione di inizio p
	 */
	public void remove(Posizione p) {
		// da implementare

	}
	

}
